public class CharPointer {
    char pointer[];
    int index;
    public CharPointer(char p[], int i){
	pointer = p;
	index = i;
    }
    public CharPointer(CharPointer cp, int i){
	pointer = cp.pointer;
	index = cp.index + i;
    }
    char[] getPointer(){
	return pointer;
    }
    int getIndex(){
	return index;
    }
    int strlen(){
	int i;

	for (i = 0; pointer[i + index] != 0; i++)
	    ;
	return i;
    }
    char charValue(int i){
	return pointer[index + i];
    }
    void assignChar(char c, int i){
	pointer[index + i] = c;
    }
    void assignInt(int n, int i){
	pointer[index + i] = (char)((n >> 24) & 0xff);
	pointer[index + 1 + i] = (char)((n >> 16) & 0xff);
	pointer[index + 2 + i] = (char)((n >> 8) & 0xff);
	pointer[index + 3 + i] = (char)((n >> 0) & 0xff);
    }
    void assignInt(int n){
	assignInt(n, 0);
    }
    int intValue(int i){
	return (pointer[index + i] << 24)
	    + (pointer[index + 1 + i] << 16)
		+ (pointer[index + 2 + i] << 8)
		    + (pointer[index + 3 + i] << 0);
    }
    int intValue(){
	return intValue(0);
    }
    void assignPattIni(int s, float h, float d){
//	int style;		/* style number */
//	float height;		/* height */
//	float dwell_ratio;	/* dwell ratio */

	int hh, hl;
	int dh, dl;

	assignInt(s, 0);
	hh = (int)h;
	hl = (int)((h - (int)h) * (1 << 31)); //
	assignInt(hh, 4);
	assignInt(hl, 8);
	dh = (int)d;
	dl = (int)((d - (int)d) * (1 << 31)); //
	assignInt(dh, 12);
	assignInt(dl, 16);
    }
    int getStyle(){
	return intValue(0);
    }
    float getHeight(){
	int h, l;
	float f;

	h = intValue(4);
	l = intValue(8);
	f = h + (float)l / (1 << 31);
	return f;
    }
    float getDwellRatio(){
	int h, l;
	float f;

	h = intValue(12);
	l = intValue(16);
	f = h + (float)l / (1 << 31);
	return f;
    }
    char[] getString(){
	int i, n;
	char c[];

	for (n = 0; pointer[index + n] != 0; n++)
	    ;
	c = new char[n + 1];
	for (i = 0; i < n; i++){
	    c[i] = pointer[index + i];
	}
	c[i] = 0;
	return c;
    }
    void printOn(){
	int i;
	for (i = index; i < pointer.length; i++){
	    System.out.println(pointer[i]);
	}
    }
}

