import java.io.*;
import java.net.*;
import java.awt.*;

public class Jm implements Master {
    public final static float KW = 0.25f;
    public final static int XR = 1024;
    public final static int DW = 290;
    public final static int BMAX = 35;
    public final static int LMAX = 76;
    public final static int MMAX = 11;
    public final static int TMAX = 40;
    public final static int MENUMAX = 20;
    public final static int FILEMAX = 9999;
    public final static int STYLENUMBER = 300;
    public final static int STYLEMAX = 3000;
    public final static int BLOCK_SIZE = 1024;
    public final static int STYLE_HEAD = 4 + 8 + 8;
    public final static int HPNLEN = 30; /* length of style names */
    public final static String COPYRIGHT
	= "JuggleMaster Version 1.60  Copyright (c) 1995-1996 Ken Matsuoka";
    public final static int OBJECT_HAND = 0x01;
    public final static int OBJECT_UNDER = 0x02;
    public final static int OBJECT_MOVE = 0x04;
    public final static int OBJECT_MOVE2 = 0x08;

    public final static int EOF = -1;

    CharPointer pp1[];
    CharPointer pp2[];
    char pp3[] = new char[STYLEMAX * 4];
    Style patths[] = new Style[STYLENUMBER];
    
    int throw_max = -1;
    Style style0 = new Style();
    Arm ap = new Arm();    

    float ga = 9.8f;
    float dwell_ratio = 0.5f;
    float hr0 = .20f;
    int base;
    int mirror = 0;
    
    /*unsigned*/ long time_count;
    int time_period;
    
    float speed = 1.0f;
    int beep = 1;
    int throw_ = 0;
    int syn = 0;
    int hand_on = 1;
    int back_on = 1;
    int mp = 0;
    int mpw = 1;
    int fpu = 0;
    char backpal[] = {0, 0, 0};

    Ball rhand = new Ball(), lhand = new Ball();
    Ball b[] = new Ball[BMAX];
    int tw;
    int aw;
    int balln;
    int pmax;
    char pbuf[];
    String fbuf;

    int patt[][] = new int[LMAX][MMAX];
    int patts[] = new int[LMAX];
    int pattw;
    int r[] = new int[LMAX*2];
    char pal[] = new char[48];
    float smode;
    char expath[] = new char[256];
    long high0[] = new long[BMAX+1];
    float high[] = new float[BMAX+1];
    int patt_x;

    int kw0;

    int nTitles;
    int vsync_Count1;
    int mono_opt;

    int ev_loop = 0;

    X11 x11;

    public Jm(X11 x){
	int i;

	x11 = x;
	for (i = 0; i < BMAX; i++){
	    b[i] = new Ball();
	}
	for (i = 0; i < STYLENUMBER; i++){
	    patths[i] = new Style();
	}
	Extern.status = ST_NONE; //test
    }
    boolean jm_main(){
	int error;

	set_machine();
	fpu = 1;

	patths[0].name = "Normal";
	patths[0].length = 1;
	patths[0].t = 0;
	pp3[0] = 13;
	pp3[1] = 0;
	pp3[2] = 4;
	pp3[3] = 0;
	throw_max = 0;

	pbuf = new char[256];
	if ((error = menu_set()) == 0){
	    x11.setPatternTitles(pp2, nTitles);
	    return true;
	}
	else {
	    return false;
	}
    }
    void set_dpm(){
	float speed0;
	int i,gy_max,gy_min;
	
	speed0 = speed;
	speed = 2;
	base = 0;
	Extern.dpm = 400;
	gy_max = 80 - 11;
	gy_min = -200 - 11;
	Extern.gx_max = -1000;
	Extern.gx_min = 1000;
	
	if(set_ini(1) == 0){
	    for(time_count = 0;
		time_count < tw * (pattw + pmax + style0.length);
		time_count++){
		for(i = 0; i < balln; i++){
		    juggle(b[i]);
		    gy_max = Math.max(gy_max, b[i].gy);
		    gy_min = Math.min(gy_min, b[i].gy);
		    Extern.gx_max = Math.max(Extern.gx_max, b[i].gx);
		    Extern.gx_min = Math.min(Extern.gx_min, b[i].gx);
		}
		
		juggle(rhand);
		juggle(lhand);
		
		gy_max = Math.max(gy_max, rhand.gy);
		gy_min = Math.min(gy_min, rhand.gy);
		gy_max = Math.max(gy_max, lhand.gy);
		gy_min = Math.min(gy_min, lhand.gy);
		Extern.gx_max = Math.max(Extern.gx_max, rhand.gx);
		Extern.gx_min = Math.min(Extern.gx_min, rhand.gx);
		Extern.gx_max = Math.max(Extern.gx_max, lhand.gx);
		Extern.gx_min = Math.min(Extern.gx_min, lhand.gx);
		
		ap.rx[0] = rhand.gx + 11 + Extern.arm_x;
		ap.ry[0] = rhand.gy + 11 + Extern.arm_y;
		ap.lx[0] = lhand.gx + 11 - Extern.arm_x;
		ap.ly[0] = lhand.gy + 11 + Extern.arm_y;
		arm_line();
		for (i = 0; i < 5; i++) {
		    Extern.gx_max = Math.max(Extern.gx_max, ap.rx[i]);
		    Extern.gx_max = Math.max(Extern.gx_max, ap.lx[i]);
		    Extern.gx_min = Math.min(Extern.gx_min, ap.rx[i]);
		    Extern.gx_min = Math.min(Extern.gx_min, ap.lx[i]);
		}
	    }
	}
	
	if(gy_max-gy_min > 0){
	    Extern.dpm = (int)((float)400 * 340 / (gy_max - gy_min));
	    if(Extern.dpm > DW){
		Extern.dpm = DW;
	    }
	    base = (int)(370 - (float)gy_max * Extern.dpm / 400);
	}
	speed = speed0;
    }
    int juggle(Ball d){
	int tp, flag = 0, i, tpox = 0, rpox = 0, tpoz = 0, rpoz = 0;
	long x, y;
    
	d.gx0 = d.gx;
	d.gy0 = d.gy;
	
	if(d.c < 0){
	    if(time_count >= -d.c * tw){
		d.c = -d.c;
	    }
	}
	while(true){
	    tp = (int)(time_count - tw * Math.abs(d.c));
	    if(tp <aw){
		break;
	    }
	    d.st &= ~OBJECT_UNDER;
	    d.c0 = d.c;
	    
	    if((d.st & OBJECT_HAND) != 0){
		d.c += 2;
		flag = 1;
	    }
	    else{
		int t;
	    
		t = d.c;
	    
		if(syn != 0){
		    if(mirror != 0&& d.chand == 0){
			t++;
		    }
		    else if (mirror == 0 && d.chand != 0){
			t++;
		    }
		}
		
		t %= pattw;
		d.bh = patt[t][r[t]];
		d.c+= Math.abs(d.bh);
		if(++r[t] >= patts[t]){
		    r[t] = 0;
		}
		
		d.thand = d.chand;
		if(((d.bh & 1) != 0)|| d.bh < 0){
		    d.chand = 1 - d.chand;
		}
		flag = 1;
	    }
	}
	
	if( d.c >= 0 && tp >= 0 && (d.st & OBJECT_UNDER) == 0){
	    d.st |= OBJECT_UNDER;
	    
	    if((d.st & OBJECT_HAND) != 0){
		if((d.st & OBJECT_MOVE2) != 0){
		    d.st |= OBJECT_MOVE;
		    d.st &= ~OBJECT_MOVE2;
		}
		else{
		    d.st &= ~OBJECT_MOVE;
		}
	    }
	    else{
		int h;
		int t;
		
		t = d.c;
		
		if(syn != 0){
		    if(mirror != 0 && d.chand == 0){
			t++;
		    }
		    else if(mirror == 0 && d.chand != 0) {
			t++;
		    }
		}
		
		t %= pattw;
		
		if (d.bh == 1){
		    d.st |= OBJECT_MOVE;
		}
		else {
		    d.st &= ~OBJECT_MOVE;
		}
		for(i = 0; i < patts[t]; i++){
		    h = patt[t][i];
		    if(h == 1){
			if (d.chand != 0){
			    lhand.st |= OBJECT_MOVE2;
			}
			else {
			    rhand.st |= OBJECT_MOVE2;
			}
		    }
		    if(h != 2){
			if (d.chand != 0){
			    rhand.st |= OBJECT_MOVE2;
			}
			else {
			    lhand.st |= OBJECT_MOVE2;
			}
			d.st |= OBJECT_MOVE;
		    }
		}
	    }
	}
	
	
	Int tpox_p = new Int(0);
	Int tpoz_p = new Int(0);
	Int rpox_p = new Int(0);
	Int rpoz_p = new Int(0);
	if((d.st & OBJECT_MOVE) == 0){
	    if(d.c < 0){
		hand_pos(-d.c, d.chand, tpox_p, tpoz_p);
		tpox = tpox_p.intValue();
		tpoz = tpoz_p.intValue();
		rpox = tpox;
		rpoz = tpoz;
	    }
	    else{
		if((d.st & OBJECT_UNDER) != 0){
		    hand_pos(d.c, d.chand, tpox_p, tpoz_p);
		    tpox = tpox_p.intValue();
		    tpoz = tpoz_p.intValue();
		    hand_pos(d.c + 2, d.chand, rpox_p, rpoz_p);
		    rpox = rpox_p.intValue();
		    rpoz = rpoz_p.intValue();
		    if(tpox != rpox || tpoz != rpoz){
			hand_pos(d.c + 1, d.chand, rpox_p, rpoz_p);
			rpox = rpox_p.intValue();
			rpoz = rpoz_p.intValue();
			if(tpox != rpox || tpoz != rpoz){
			    d.st |= OBJECT_MOVE;
			}
		    }
		}
		else{
		    hand_pos(d.c - 2, d.chand, tpox_p, tpoz_p);
		    tpox = tpox_p.intValue();
		    tpoz = tpoz_p.intValue();
		    hand_pos(d.c  ,d.chand, rpox_p, rpoz_p);
		    rpox = rpox_p.intValue();
		    rpoz = rpoz_p.intValue();
		    if(tpox != rpox || tpoz != rpoz){
			hand_pos(d.c - 1, d.chand, tpox_p, tpoz_p);
			tpox = tpox_p.intValue();
			tpoz = tpoz_p.intValue();
			if(tpox != rpox || tpoz != rpoz){
			    d.st |= OBJECT_MOVE;
			}
		    }
		}
	    }
	}
	
	if((d.st & OBJECT_MOVE) != 0){
	    if(d.bh == 1){
		hand_pos(d.c0 + 1, d.thand, tpox_p, tpoz_p);
		tpox = tpox_p.intValue();
		tpoz = tpoz_p.intValue();
		hand_pos(d.c + 1, d.chand, rpox_p, rpoz_p);
		rpox = rpox_p.intValue();
		rpoz = rpoz_p.intValue();
	    }
	    else if((d.st & OBJECT_UNDER) != 0){
		hand_pos(d.c ,d.chand, tpox_p, tpoz_p);
		tpox = tpox_p.intValue();
		tpoz = tpoz_p.intValue();
		hand_pos(d.c + 1 ,d.chand, rpox_p, rpoz_p);
		rpox = rpox_p.intValue();
		rpoz = rpoz_p.intValue();
	    }
	    else{
		hand_pos(d.c0 + 1, d.thand, tpox_p, tpoz_p);
		tpox = tpox_p.intValue();
		tpoz = tpoz_p.intValue();
		hand_pos(d.c, d.chand, rpox_p, rpoz_p);
		rpox = rpox_p.intValue();
		rpoz = rpoz_p.intValue();
	    }
	}
	
	if(fpu != 0){
	    float fx;
	    
	    if( (d.st & OBJECT_HAND) == 0 && d.c < 0 ){
		if(tpox == 0){
		    fx = 0;
		    y = (long)((float)tpoz * Extern.dpm / 20
			       - (long)tp * Extern.dpm / 12 / tw);
		}
		else{
		    if(tpox > 0){
			fx = (float)tpox / 10 - (float)tp / 6 / tw;
		    }
		    else {
			fx = (float)tpox / 10 + (float)tp / 6 / tw;
		    }
		    y = (int)((float)tpoz * Extern.dpm / 20);
		}
	    }
	    else if((d.st & OBJECT_MOVE) == 0){
		fx = (float)tpox / 10;
		y = (int)((float)tpoz * Extern.dpm / 20);
	    }
	    else{
		if(d.bh==1){
		    fx = (float)(tp - aw) / tw * 2 + 1;
		    y = (long)((float)high[1] * (1 - jijo(fx)));
		}
		else if((d.st & OBJECT_UNDER) != 0){
		    fx = (float)tp / aw * 2 - 1;
		    y = (long)((float)high[0] * (1 - jijo(fx)));
		}
		else{
		    fx = (float)tp / (tw * Math.abs(d.bh) - aw) * 2 + 1;
		    y = (long)((float)high[Math.abs(d.bh)] * (1 - jijo(fx)));
		}
		
		y += (float)(fx * (rpoz - tpoz) + rpoz + tpoz)
		    * Extern.dpm / 40;
		fx = (fx * (rpox - tpox) + rpox + tpox) / 20;
	    }
	    
	    x = (long)(fx * Extern.dpm * KW);
	}
	else{
	    if( (d.st & OBJECT_HAND) == 0 && d.c < 0 ){
		if(tpox == 0){
		    x = 0;
		    y = tpoz * Extern.dpm / 20
			- (long)tp * Extern.dpm / 12 / tw;
		}
		else{
		    if(tpox > 0){
			x = XR * tpox / 10 - XR * tp / 6 / tw;
		    }
		    else {
			x = XR * tpox / 10 + XR * tp / 6 / tw;
		    }
		    y = tpoz * Extern.dpm / 20;
		}
	    }
	    else if((d.st & OBJECT_MOVE) == 0){
		x = XR * tpox / 10;
		y = tpoz * Extern.dpm / 20;
	    }
	    else{
		if(d.bh == 1){
		    x = XR * (tp - aw) * 2 / tw + XR;
		    y = (long)((jijo(XR) - jijo(x)) / high0[1]);
		}
		else if((d.st & OBJECT_UNDER) != 0){
		    x = XR * tp * 2 / aw - XR;
		    y = (long)((jijo(XR) - jijo(x)) / high0[0]);
		}
		else{
		    x = XR * tp * 2 / (tw * Math.abs(d.bh) - aw) + XR;
		    y = (long)((jijo(XR) - jijo(x)) / high0[Math.abs(d.bh)]);
		}
		
		y += (x * (rpoz - tpoz) + XR * (rpoz + tpoz))
		    * Extern.dpm / XR / 40;
		x  = (x * (rpox - tpox) + XR * (rpox + tpox)) / 20;
	    }
	    
	    x = x * Extern.dpm / kw0;
	}
	d.gx = (int)(HOR_CENTER + x - 11);

	if((d.st & OBJECT_HAND) != 0){
	    if(d.chand != 0){
		d.gx += Extern.hand_x;
	    }
	    else {
		d.gx -= Extern.hand_x;
	    }
	    y -= Extern.hand_y;
	}

	d.gy = (int)(base - y - 11);

	return flag;
    }
    void wprint1(int x, int y, String str, int a){
        x11.vtext_putsa(x, y, str, a);
    }
    void set_machine(){
        if ( smode <= 0.0 )
            smode = 50.00f;
    }
    void hand_pos(int c ,int h, Int x, Int z){
	int a;
	
	if(mirror != 0){
	    if(syn == 0 &&  h != 0){
		c--;
	    }
	    if((c & 1) != 0){
		a = (style0.t + (--c + h) % style0.length) * 4 + 2;
	    }
	    else {
		a = (style0.t + (c + h) % style0.length) * 4;
	    }
	}
	else{
	    if(syn == 0&& h == 0){
		c--;
	    }
	    if ((c & 1) != 0){
		a = (style0.t + (c - h) % style0.length) * 4 + 2;
	    }
	    else {
		a = (style0.t + (c + 1 - h) % style0.length) * 4;
	    }
	}
	if(h != 0){
//	    *x= pp3[a];
	    x.intValue(char_to_int(pp3[a]));
	}
	else {
//	    *x=-pp3[a];
	    x.intValue(-char_to_int(pp3[a]));
	}
//	*z=pp3[a+1];
	z.intValue(char_to_int(pp3[a + 1]));
    }
    void arm_line(){
	int mx,my,k;
	int sx,sy;
	
	sx = (int)((long)Extern.dpm * XR / kw0);
	sy = base - Extern.dpm / 3;
	
	ap.rx[1] = (ap.rx[0] + (HOR_CENTER + sx) * 2) / 3 + Extern.dpm / 12;
	ap.lx[1] = (ap.lx[0] + (HOR_CENTER - sx) * 2) / 3 - Extern.dpm / 12;
	ap.ry[1] = (ap.ry[0] + sy) / 2 + Extern.dpm / 8;
	ap.ly[1] = (ap.ly[0] + sy) / 2 + Extern.dpm / 8;
	
	ap.rx[2] = (ap.rx[1] + (HOR_CENTER + sx) * 3) / 4;
	ap.lx[2] = (ap.lx[1] + (HOR_CENTER - sx) * 3) / 4;
	ap.ry[2] = (ap.ry[1] + sy * 2) / 3 - Extern.dpm / 25;
	ap.ly[2] = (ap.ly[1] + sy * 2) / 3 - Extern.dpm / 25;
	
	ap.rx[3] = (ap.rx[2] + (HOR_CENTER + sx) * 2) / 3 - Extern.dpm / 13;
	ap.lx[3] = (ap.lx[2] + (HOR_CENTER - sx) * 2) / 3 + Extern.dpm / 13;
	ap.ry[3] = (ap.ry[2] + sy * 2) / 3 - Extern.dpm / 40;
	ap.ly[3] = (ap.ly[2] + sy * 2) / 3 - Extern.dpm / 40;
	
	mx = (ap.rx[3] + ap.lx[3]) / 2;
	my = (ap.ry[3] + ap.ly[3]) / 2;
	
	ap.rx[4] = (mx * 2 + ap.rx[3]) / 3;
	ap.lx[4] = (mx * 2 + ap.lx[3]) / 3;
	ap.ry[4] = (my * 2 + ap.ry[3]) / 3;
	ap.ly[4] = (my * 2 + ap.ly[3]) / 3;
	
	ap.hx = mx;
	ap.hy = (my * 2 - Extern.dpm * 2 / 3 + base) / 3;
	ap.hr = Extern.dpm / 11;
	
	ap.rx[5] = ap.hx + Extern.dpm / 20;
	ap.lx[5] = ap.hx - Extern.dpm / 20;
	ap.ry[5] = ap.hy + Extern.dpm / 13;
	ap.ly[5] = ap.ry[5];
    }
    int put_balls_x(Image bm[], Image r_bm[], Image l_bm[],
		    Graphics bm_gc[], Graphics r_bm_gc[], Graphics l_bm_gc[]){
	int i;
	
//	vgc_setcolor(VGA_PSET,0);
	x11.vgc_setcolor(0);

	if(hand_on != 0){
//#ifdef JMX
//#define gx1 gx0
//#define gy1 gy0
//#endif

	    ap.rx[0] = rhand.gx0 + 11 + Extern.arm_x;
	    ap.ry[0] = rhand.gy0 + 11 + Extern.arm_y;
	    ap.lx[0] = lhand.gx0 + 11 - Extern.arm_x;
	    ap.ly[0] = lhand.gy0 + 11 + Extern.arm_y;
	    arm_line();
	    
	    for(i = 0;i < 5;i++){
		x11.vgc_line(ap.rx[i], ap.ry[i], ap.rx[i + 1], ap.ry[i + 1]);
		x11.vgc_line(ap.lx[i], ap.ly[i], ap.lx[i + 1], ap.ly[i + 1]);
	    }
	    x11.vgc_circle_x(ap.hx, ap.hy, ap.hr);

	    x11.vgc_byteboxfill_x(
		rhand.gx0 / 8, rhand.gy0 + Extern.bm1,
		rhand.gx0 / 8 + 3, rhand.gy0 + Extern.bm2);
	    x11.vgc_byteboxfill_x(
		lhand.gx0 / 8, lhand.gy0 + Extern.bm1,
		lhand.gx0 / 8 + 3, lhand.gy0 + Extern.bm2);
	}
	for(i = balln - 1;i >= 0;i--){
	    x11.vgc_byteboxfill_x(
		b[i].gx0 / 8, b[i].gy0 + Extern.bm1,
		b[i].gx0 / 8 + 3, b[i].gy0 + Extern.bm2);
	}

//#ifdef JMX
//#undef gx1
//#undef gy1
//#endif
	
	if(hand_on != 0){
	    ap.rx[0] = rhand.gx + 11 + Extern.arm_x;
	    ap.ry[0] = rhand.gy + 11 + Extern.arm_y;
	    ap.lx[0] = lhand.gx + 11 - Extern.arm_x;
	    ap.ly[0] = lhand.gy + 11 + Extern.arm_y;
	    arm_line();
//	    vgc_setcolor(VGA_PSET, 1);
	    x11.vgc_setcolor(1);
		
	    x11.put_bm_x(r_bm, r_bm_gc, rhand.gx, rhand.gy);
	    x11.put_bm_x(l_bm, l_bm_gc, lhand.gx - 1, lhand.gy);
	    for(i = 0; i < 5; i++){
		x11.vgc_line(ap.rx[i], ap.ry[i], ap.rx[i + 1], ap.ry[i + 1]);
		x11.vgc_line(ap.lx[i], ap.ly[i], ap.lx[i + 1], ap.ly[i + 1]);
	    }
	    x11.vgc_circle_x(ap.hx, ap.hy, ap.hr);
	}

	for(i = balln - 1;i >= 0;i--){
//	    vgc_setcolor(VGA_PSET, 15 - i % 13);
	    x11.vgc_setcolor(15 - i % 13);
	    x11.put_bm_x(bm, bm_gc, b[i].gx, b[i].gy);
	}

	return 0;
    }
    int set_patt(char s[]){
        int i, l, flag = 0, flag2 = 0, a = 0;
	int s_index = 0;
        
	l = strlen(s);

        if (l > LMAX){
	    return 10;
        }
        pattw = 0;
        balln = 0;
        
        if (s[s_index] == '('){
	    syn = 1;
	}
        else {
	    syn = 0;
        }
        for (i = 0; i < LMAX; i++){
	    if (i >= l){
		if (flag != 0 || flag2 != 0){
		    return 4;
		}
		break;
	    }
	    if (s[s_index] == '['){
		flag2 = 1;
		patts[pattw] = 0;
		s_index++;
		continue;
	    }
	    if (s[s_index] == ']'){
		if (flag2 == 0){
		    return 4;
		}
		flag2 = 0;
		pattw++;
		s_index++;
		continue;
	    }
	    if (syn == 1){
		switch(s[s_index]){
		  case '(':
		    if (flag != 0){
			return 4;
		    }
		    flag = 1;
		    s_index++;
		    continue;
		  case ')':
		    if (flag != 5){
			return 4;
		    }
		    flag = 0;
		    s_index++;
		    continue;
		  case ',':
		    if (flag != 2){
			return 4;
		    }
		    flag = 4;
		    s_index++;
		    continue;
		  case 'X':
		  case 'x':
		    if (flag != 2 && flag != 5){
			return 4;
		    }
		    if (flag2 != 0){
			patt[pattw][patts[pattw] - 1] = -a;
		    }
		    else {
			patt[pattw - 1][0] = -a;
		    }
		    s_index++;
		    continue;
		}
	    }
	    a = ctod(s[s_index]);
	    if (a == -1){
		return 6;
	    }
	    if (syn != 0){
		if (a % 2 != 0){
		    return 7;
		}
		if (flag2 == 0 && flag != 1 && flag != 4){
		    return 4;
		}
		if (flag == 1){
		    flag = 2;
		}
		if (flag == 4){
		    flag = 5;
		}
	    }
	    if (flag2 != 0){
		if (a == 0){
		    return 13;
		}
		patt[pattw][patts[pattw]++] = a;
		if (patts[pattw] >MMAX){
		    return 8;
		}
	    }
	    else{
		patt[pattw][0] = a;
		if (a == 0){
		    patts[pattw++] = 0;
		}
		else {
		    patts[pattw++] = 1;
		}
	    }
	    s_index++;
	    balln += a;
	}
        
        if (pattw == 0){
	    return 9;
	}
        balln /= pattw;
        
        return 0;
    }
    int ctod(char c){
        if (c >= '0' && c <= '9'){
	    return c - '0';
	}
        else if (c >= 'a' && c <= 'z'){
	    return c - 'a' + 10;
	}
        else if (c >= 'A' && c <= 'Z'){
	    return c - 'A' + 10;
        }
        return -1;
    }
    int set_ini(int rr){
	int i, j, k;
	float tw0, aw0;

	balln = 0;
	pmax = 0;

	if (pattw > LMAX){
	    return 10;
	}

	for (i = 0; i < pattw; i++){
	    for (j = 0; j < patts[i]; j++){
		balln += Math.abs(patt[i][j]);
		pmax = Math.max(pmax, Math.abs(patt[i][j]));
	    }
	}
	if (balln % pattw != 0){
	    return 5;
	}
	balln /= pattw;
	if (balln == 0){
	    return 9;
	}
	if (balln > BMAX){
	    return 9;
	}
	for (i = 0; i < LMAX * 2; i++){
	    r[i] = 0;
	}
        for (i = 0; i <= balln; i++){
	    j = 0;
	    while (r[j] == patts[j % pattw] && j < pattw + pmax){
		j++;
	    }
	    if (i == balln){
		if (j == pattw+pmax){
		    break;
		}
		else {
		    return 5;
		}
	    }
	    b[i].st = 0;
	    
	    if (mirror != 0){
		if ((j + syn) % 2 != 0){
		    b[i].thand = 1;
		    b[i].chand = 1;
		}
		else {
		    b[i].thand = 0;
		    b[i].chand = 0;
		}
	    }
	    else{
		if ((j + syn) % 2 != 0){
		    b[i].thand = 0;
		    b[i].chand = 0;
		}
		else {
		    b[i].thand = 1;
		    b[i].chand = 1;
		}
	    }
	    if (syn != 0){
		b[i].c = -((int)(j / 2)) * 2;
	    }
	    else {
		b[i].c = -j;
	    }
	    while (j < pattw + pmax){
		if (r[j] == patts[j % pattw]){
		    return 5;
		}
		else {
		    r[j]++;
		}
		k = patt[j % pattw][patts[j % pattw] - r[j]];
		if (syn != 0 && k < 0){
		    if (j % 2 == 0){
			j += -k + 1;
		    }
		    else {
			j += -k - 1;
		    }
		}
		else {
		    j+=k;
		}
	    }
	}
        if (rr == 0){
	    return 0;
	}
        if (pmax < 3){
	    pmax = 3;
	}
        tw0 = (float)Math.sqrt(2 / ga * pmax * hr0) * 2
	    / (pmax - dwell_ratio * 2) * smode / speed;
        tw = (int)fadd(tw0, 0, 0);
        if (tw == 0){
	    return 15;
	}
        aw0 = tw0 * dwell_ratio * 2;
        aw = (int)fadd(aw0, 0, 0);
        if (aw < 1){
	    aw = 1;
	}
        if (aw > tw * 2 - 1){
	    aw = tw * 2 - 1;
	}
        patt_x = (IMAGE_WIDTH / 8 / 2) - strlen(pbuf) / 2;
        
        kw0 = (int)((float)XR / KW);
/*
        style0.t = (patths + throw)->t;
        style0.length=(patths+throw)->length;
*/
        style0.t = patths[throw_].t;
        style0.length = patths[throw_].length;
        
        if (fpu != 0){
	    high[0] = -.2f * Extern.dpm;
	    high[1] = (int)(ga * jijo(tw0 / smode * speed) / 8 * Extern.dpm);
	    for (i = 2; i <= pmax; i++){
		high[i] = (int)(ga * jijo((tw0 * i - aw0) / smode * speed)
		    / 8 * Extern.dpm);
	    }
	}
        else{
	    high0[0] = (long)(-jijo(XR) / (.2f * Extern.dpm));
	    high0[1] = (long)(jijo(XR)
			      / (float)(ga * jijo(tw0 / smode * speed)
					/ 8 * Extern.dpm));
	    for (i = 2;i <= pmax; i++){
		high0[i] = (long)(jijo(XR)
		    / (float)(ga * jijo((tw0 * i - aw0)
					/ smode * speed) / 8 * Extern.dpm));
	    }
	}
	for (i = 0;i < balln; i++){
	    b[i].bh = 0;
	    b[i].gx = HOR_CENTER;
	    b[i].gy = VER_CENTER;
	    b[i].gx0 = HOR_CENTER;
	    b[i].gy0 = VER_CENTER;
	    b[i].gx1 = HOR_CENTER;
	    b[i].gy1 = VER_CENTER;
	}
	if (mirror != 0){
	    lhand.c=0;
	    if (syn != 0){
		rhand.c = 0;
	    }		
	    else {
		rhand.c = -1;
	    }
	}
        else {
	    rhand.c = 0;
	    if (syn != 0){
		lhand.c = 0;
	    }
	    else {
		lhand.c = -1;
	    }
	}
	rhand.bh = 2;
	rhand.st = OBJECT_HAND;
	rhand.thand = 1;
	rhand.chand = 1;
        rhand.gx  = HOR_CENTER;
	rhand.gy  = VER_CENTER;
        rhand.gx0 = HOR_CENTER;
	rhand.gy0 = VER_CENTER;
        rhand.gx1 = HOR_CENTER;
	rhand.gy1 = VER_CENTER;
        
        lhand.bh = 2;
        lhand.st = OBJECT_HAND;
        lhand.thand = 0;
	lhand.chand = 0;
        lhand.gx  = HOR_CENTER;
	lhand.gy  = VER_CENTER;
        lhand.gx0 = HOR_CENTER;
	lhand.gy0 = VER_CENTER;
        lhand.gx1 = HOR_CENTER;
	lhand.gy1 = VER_CENTER;
        
        for (i = 0; i < pattw; i++){
	    r[i] = 0;
        }
        return 0;
    }
    float jijo(float x){
	return x * x;
    }
    //static char buf[256];
    char patt1_buf[] = new char[256];
    char[] patt1(int i){
	char p[];
        int j,t;
	int index = 0;
        
        p = patt1_buf;
        
        if (syn != 0){
//	    *p = '(';
	    p[index] = '(';
//	    p++;
	    index++;
	}
        for (t = 0; t <= syn; t++){
	    if(t != 0){
//		*p = ',';
		p[index] = ',';
//		p++;
		index++;
	    }
	    if (patts[i] == 0){
//		*p = '0';
		p[index] = '0';
//		p++;
		index++;
	    }
	    else {
		if (patts[i] > 1){
//		    *p = '[';
		    p[index] = '[';
//		    p++;
		    index++;
		}
		for (j = 0; j < patts[i]; j++){
		    if (Math.abs(patt[i][j]) < 10){
//			*p = '0' + Math.abs(patt[i][j]);
			p[index] = (char)('0' + Math.abs(patt[i][j]));
		    }
		    else {
//			*p = 'a' + Math.abs(patt[i][j]) - 10;
			p[index] = (char)('a' + Math.abs(patt[i][j]) - 10);
		    }
//		    p++;
		    index++;
		    if (patt[i][j] < 0){
//			*p = 'x';
			p[index] = 'x';
//			p++;
			index++;
		    }
		}
		if(patts[i] > 1){
//		    *p = ']';
		    p[index] = ']';
//		    p++;
		    index++;
		}
	    }
	    i++;
	}
        if(syn != 0){
//	    *p = ')';
	    p[index] = ')';
//	    p++;
	    index++;
	}
//        *p = '\0';
	p[index] = '\0';
        
        return patt1_buf;
    }
    /*static*/ int tx,c,c0;
    void patt_print(int mode){
        int attr;
        int i;
	char p[];
	int l;
        
        if(mode != 0){
	    if(c0 < pattw && pattw > 1 + syn){
		attr = 0;
		p = patt1(c0);
//		wprint1(patt_x + tx, 0, p, attr);
//		tx += strlen(p);
		l = strlen(p);
		wprint1(patt_x + tx, 0, new String(p, 0, l), attr);
		tx += l;
	    }
	    c = time_period;
	    if(c <= c0){
		tx = 0;
	    }
	    attr = TX_REVERSE;
	    p = patt1(c);
//	    wprint1(patt_x + tx, 0, p, attr);
	    l = strlen(p);
	    wprint1(patt_x + tx, 0, new String(p, 0, l), attr);
	    c0 = c;
	}
        else{
	    attr = 0;
	    tx = 0;
	    for(i = 0;i < pattw; i += syn + 1){
		p = patt1(i);
//		wprint1(patt_x + tx, 0, p, attr);
//		tx += strlen(p);
		l = strlen(p);
		wprint1(patt_x + tx, 0, new String(p, 0, l), attr);
		tx += l;
	    }
	    c0 = pattw;
	}
        return;
    }
    Image bm[] = new Image[NCOLOR];
    Image r_bm[] = new Image[NCOLOR];
    Image l_bm[] = new Image[NCOLOR];

    Graphics bm_gc[] = new Graphics[NCOLOR];
    Graphics r_bm_gc[] = new Graphics[NCOLOR];
    Graphics l_bm_gc[] = new Graphics[NCOLOR];

    void jug_start(){
        int i, j, t, sflag = 0, attr;
        x11.x_all_clear();
        set_dpm();

        if(set_ini(1) != 0){
	    return;
	}
        x11.xbitset(bm, r_bm, l_bm, bm_gc, r_bm_gc, l_bm_gc);
        x11.gr_sync(null);

	if(back_on==1){
	    patt_print(0);
	}
        time_count = 0;
        time_period = 0;

	x11.vga_vsync_start();
    }
    int wleft(char w[], InputStream fp, Int len_p,
	      int lmax, /*unsigned */int type){
	int c = 0,c2 = 0,i = 0,j = 0;
	
	c = getc(fp);
	
	if((type & 4) != 0){
	    while(c == ' ' || c == '\t'){
		c = getc(fp);
	    }
	}
	while(i < lmax && !(c == EOF || c == '\n')){
	    if((type & 16) != 0 && (c == ' ' || c == '\t')){
		break;
	    }
	    if((c >= 0x81 && c <= 0x9F) || (c >= 0xE0 && c <= 0xFC)){
		c2 = getc(fp);
	    }
	    else if((c >= 0x20 && c <= 0x7E) || (c >= 0xA1 && c <= 0xDF)){
//		*(w+i) = c;
		w[i] = (char)c;
		i++;
	    }
	    else if((type & 1) != 0 && c == '\t'){
		for(j = 0;j < 8 - i % 8; j++){
		    if(i + j >= lmax){
			break;
		    }
//		    *(w+i+j) = ' ';
		    w[i + j] = ' ';
		}
		i+=j;
	    }
	    c = getc(fp);
	}
	
//	*(w+i) = (int)NULL;
	w[i] = 0;
	if((type & 8) != 0){
	    while(i > 0){
//		if(*(w+i-1) == ' ' || *(w+i-1) == '\t'){
		if(w[i - 1] == ' ' || w[i - 1] == '\t'){
		    i--;
//		    *(w+i) = (int)NULL;
		    w[i] = 0;
		}
		else {
		    break;
		}
	    }
	}
//	*len = i;
	len_p.intValue(i);
	
	if(c == EOF){
	    return 2;
	}
	else if(c == '\n'){
	    return 1;
	}
	else {
	    return 0;
	}
    }
    int atoi(char buf[], int index){
	int n;
	int i;
	String s;
	int sign = 1;

	for (; index < buf.length
	     && (buf[index] < '0' || buf[index] > '9') && buf[index] != '-';
	     index++)
	    ;
	if (buf[index] == '-'){
	    index++;
	    sign = -1;
	}
	for (i = 0; i + index < buf.length
	     && buf[i + index] >= '0' && buf[i + index] <= '9';
	     i++)
	    ;

	s = String.valueOf(buf, index, i);
	try {
	    n = Integer.valueOf(s).intValue();
	}
	catch (NumberFormatException e){
	    n = 0;
	}
	return n * sign;
    }
    float atof(char buf[], int index){
	float t;
	int i;
	String s;

	for (i = 0; i + index < buf.length
	     && buf[i + index] != 0
	     && buf[i + index] != '\t'
	     && buf[i + index] != '\n'
	     && buf[i + index] != ' '
	     && buf[i + index] != ';';
	     i++)
	    ;

	s = String.valueOf(buf, index, i);
	try {
	    t = Float.valueOf(s).floatValue();
	}
	catch (NumberFormatException e){
	    t = 0.0f;
	}
	return t;
    }
    char int_to_char(int i){
	if (i < 0){
	    i += 256;
	}
	return (char)i;
    }
    int char_to_int(char c){
	int n;

	if (c > 127){
	    n = (int)c - 256;
	}
	else {
	    n = (int)c;
	}
	return n;
    }
    int patth_set(char buff[], CharPointer a){
	int flag = 0,i;
	int index = 0;
	
	while(true){
//	    buff++;
	    index++;
	    
	    if(flag == 0){
//		a[0] = (char)atoi(buff);
		a.assignChar(int_to_char(atoi(buff, index)), 0);
		flag = 1;
//		while(*buff!=(int)NULL && *buff!=',') buff++;
		while(buff[index] != 0 && buff[index] != ','){
		    index++;
		}
	    }
	    else if(flag == 1){
//		a[1] = (char)atoi(buff);
		a.assignChar(int_to_char(atoi(buff, index)), 1);
		flag = 2;
//		while(*buff!=(int)NULL && *buff!='{') buff++;
		while(buff[index] != 0 && buff[index] != '{'){
		    index++;
		}
	    }
	    else if(flag == 2){
//		a[2] = (char)atoi(buff);
		a.assignChar(int_to_char(atoi(buff, index)), 2);
		flag = 3;
//		while(*buff!=(int)NULL && *buff!=',') buff++;
		while(buff[index] != 0 && buff[index] != ','){
		    index++;
		}
	    }
	    else if(flag == 3){
//		a[3] = (char)atoi(buff);
		a.assignChar(int_to_char(atoi(buff, index)), 3);
		int aa;
		for(i = 0; i < 4; i += 2){
//		    if(a[i] < -30 || a[i] > 30){
		    aa = char_to_int(a.charValue(i));
		    if (aa < -30 || aa > 30){
			return 1;
		    }
		}
		for(i = 1; i < 4; i += 2){
//		    if(a[i] < -10 || a[i] > 20){
		    aa = char_to_int(a.charValue(i));
		    if (aa < -10 || aa > 20){
			return 1;
		    }
		}
		return 0;
	    }
//	    if(*buff==(int)NULL) return 1;
	    if(buff[index] == 0){
		return 1;
	    }
	}
    }
    boolean str_equal(char p[], String q, int type){
	int p0 = 0,q0 = 0;
	char a, b;
	int index = 0;
	
	while(true){
//	    a=*(p+p0);
	    if (p0 + index < p.length){
		a = p[p0 + index];
	    }
	    else {
		a = 0;
	    }
//	    b=*(q+q0);
	    if (q0 < q.length()){
		b = q.charAt(q0);
	    }
	    else {
		b = 0;
	    }
	    if((type & 4) != 0){
		if(a >= 'A' && a <= 'Z'){
		    a += 'a'-'A';
		}
		if(b >= 'A' && b <= 'Z'){
		    b += 'a'-'A';
		}
	    }
	    if((type & 3) == 0 && b == 0){
		break;
	    }
	    if((type & 3) == 2 && b == 0){
		break;
	    }
	    if(a == b){
		if((type&3)==1 && b == 0){
		    break;
		}
		p0++;
		q0++;
	    }
	    else{
		if(a == 0){
		    return false;
		}
		if((type & 3) == 2){
		    p0 = 0;
		    q0 = 0;
//		    p++;
		    index++;
		}
		else{
		    return false;
		}
	    }
	}
	return true;
    }
    int inif_set(char buf[]){
	float t;
	int i;
/*
	char buf4[];
	
	buf4 = new char[buf.length - 4];
	for (i = 0; i < buf.length - 4 && buf[i + 4] != 0
	     && buf[i + 4] != '\t' && buf[i + 4] != '\n'
	     && buf[i + 4] != ' ' && buf[i + 4] != ';' ; i++){
	    buf4[i] = buf[i + 4];
	}
	if (i < buf.length - 4){
	    buf[i] = 0;
	}
*/
	t = atof(buf, 4);
	if(str_equal(buf,"#GA=",0)){
	    if(t <= 0 || t > 98){
		return 23;
	    }
	    ga = t;
	}
	else if(str_equal(buf,"#DR=",0)){
	    if(t < .1 || t > .9){
		return 23;
	    }
	    dwell_ratio = fadd(t,2,0);
	}
	else if(str_equal(buf,"#HR=",0)){
	    if(t < 0.01 || t > 1.00){
		return 23;
	    }
	    hr0 = fadd(t,2,0);
	}
	else if(str_equal(buf,"#MR=",0)){
	    if(t != 0 && t != 1){
		return 23;
	    }
	    mirror = (int)t;
	}
	else if(str_equal(buf,"#BP=",0)){
	    if(t != 0 && t != 1){
		return 23;
	    }
	    beep = (int)t;
	}
	else if(str_equal(buf,"#HD=",0)){
	    if(t != 0 && t != 1){
		return 23;
	    }
	    hand_on = (int)t;
	}
	else if(str_equal(buf,"#PD=",0)){
	    if(t != 0 && t != 1){
		return 23;
	    }
	    back_on = (int)t;
	}
	else if(str_equal(buf,"#SP=",0)){
	    if(t < .1 || t > 2){
		return 23;
	    }
	    speed = fadd(t,1,0);
	}
	else if(str_equal(buf,"#BC=",0)){
	    char a[];
	    a = new char[3];
	    
//	    if(strlen(buf+4) < 3){
//	    if(strlen(buf4) < 3){
	    if(strlen(buf) < 4 + 3){
		return 23;
	    }
	    for(i = 0;i < 3;i ++){
//		a[i] = ctod(*(buf+4+i));
		a[i] = (char)ctod(buf[4 + i]);
		if(a[i] < 0 || a[i] > 15){
		    return 23;
		}
	    }
	    for(i = 0;i < 3;i++){
		backpal[i] = a[i];
	    }
	}
	else{
	    return 23;
	}
	return 0;
    }
    /*static unsigned */int hpp = 0;
    int patths_set(InputStream fp, char buff[], Int fline_p){
//	char c;
	int c;
	int i,hpflag = 0,len;
	char data[];
	Int len_p;
	int fline;
	
	if(hpp == 0){
//	    hpp = patths->t+patths->length;
	    hpp = patths[0].t + patths[0].length;
	}
	c = 0; // add
	len_p = new Int(0);
	if(wleft(buff, fp, len_p, HPNLEN + 1, 1 + 2 + 4 + 8)==0){
	    while(!(c == EOF || c == '\n')){
		c = getc(fp);
	    }
	}
	len = len_p.intValue();
	if(len <= 1){
	    throw_ = -1;
	    return 0;
	}
	
	c = getc(fp);
	ungetc(c, fp);
	
	int j;
	char buff1[] = new char[strlen(buff) + 1];
	for (j = 0; j < buff.length && buff[j + 1] != 0; j++){
	    buff1[j] = buff[j + 1];
	}
	buff1[j] = 0;

	for(i = 0; i <= throw_max; i++){
//	    if(str_equal(buff1,(patths+i)->name,1)){
	    if(str_equal(buff1, patths[i].name, 1)){
		if(c == '{'){
		    throw_ = -1;
		    return 22;
		}
		else{
		    throw_ = i;
		    return 0;
		}
	    }
	}
	
	if(c == '{'){
	    if(throw_max+1 >= STYLENUMBER){
		throw_ = -1;
		return 18;
	    }
//	    if((data = malloc(len+1))==NULL) return 18;
//	    (patths+throw_max+1)->name = data;
//	    for(i = 0;i <= len;i++){
//		*(data+i) = buff[i+1];
//	    }
	    patths[throw_max + 1].name = String.valueOf(buff, 1, len);
//	    (patths+throw_max+1)->t = hpp;
	    patths[throw_max+1].t = hpp;
	}
	while(c == '{'){
	    len_p = new Int(0);
	    if(wleft(buff, fp, len_p, 80, 8) == 0){
		while(!(c == EOF || c == '\n')) {
		    c = getc(fp);
		}
	    }
	    len = len_p.intValue();
//	    (*fline)++;
	    fline = fline_p.intValue();
	    fline++;
	    fline_p.intValue(fline);

	    CharPointer pp3_p = new CharPointer(pp3, hpp * 4);
//	    if(patth_set(buff, pp3+hpp*4)==0){
	    if(patth_set(buff, pp3_p)==0){
		if(++hpp >= STYLEMAX){
		    throw_ = -1;
		    return 18;
		}
		hpflag++;
	    }
	    else{
		throw_ = -1;
		return 20;
	    }
	    c = getc(fp);
	    ungetc(c, fp);
	}
	
	if(hpflag > 0){
	    throw_max++;
//	    (patths+throw_max)->length = hpflag;
	    patths[throw_max].length = hpflag;
	    throw_ = throw_max;
	    return 0;
	}
	else{
	    throw_ = -1;
	    return 21;
	}
    }
    char []malloc(int size){
	return new char[size];
    }
    int menu_set(){
	int c = 0, line = 0, flag = 0, error = 0, i, len;
	int fline = 0,dp = 0,stend = 0;
	char data[];
	char buff[] = malloc(256);
	
	InputStream fp;
	Int len_p;
	
	String url;
	if (x11.menu_flag){
	    fbuf = x11.getParameter("file");
	    url = fbuf;
	    x11.menu_flag = false;
	}
	else {
	    url = x11.getText();
	}
        try {
            URL u = new URL(url);
            URLConnection uc = u.openConnection();
            fp = uc.getInputStream();
        }
	catch (MalformedURLException e1) {
	    try {
		URL u = new URL(x11.getCodeBase() + url);
		URLConnection uc = u.openConnection();
		fp = uc.getInputStream();
		url = x11.getCodeBase() + url;
	    }
	    catch (MalformedURLException e2) {
		try {
		    fp = new FileInputStream(url);
		} catch (FileNotFoundException e3) {
		    return 3;
		} catch (IOException e4){
		    return 3;
		}
	    }
	    catch (IOException e5){
		return 3;
	    }
        }
	catch (IOException e6){
            return 3;
        }
	x11.setText(url);
	pp1 = new CharPointer[FILEMAX];
	pp2 = new CharPointer[FILEMAX];
	data = malloc(BLOCK_SIZE);
	
	dp = 0;
	throw_ = -1;
	
	while (true){
	    if(error != 0){
		System.out.println(
		    "Error line:" + fline + " " + buff);
		flag = 1;
		if(error == 17){
		    pbuf = null;
		    break;
		}
	    }
	    error = 0;
	    fline++;
	    c = getc(fp);
	    if(c == EOF){
		break;
	    }
	    if(c == ';'){
		while(!(c == EOF || c == '\n')){
		    c = getc(fp);
		}
		continue;
	    }
	    
	    if(line >= FILEMAX){
		error = 17;
		continue;
	    }
	    else if(c == '/'){
		if(stend == 1){
		    stend = 0;
		}
		len_p = new Int(0);
		if(wleft(buff, fp, len_p, TMAX, 2 + 8) == 0){
		    while(!(c == EOF || c == '\n')){
			c = getc(fp);
		    }
		}
		len = len_p.intValue();
		if(dp + len + 2 + STYLE_HEAD >= BLOCK_SIZE){
		    data = malloc(BLOCK_SIZE);
		    dp = 0;
		}
		//		pp1[line] = data + dp;
		pp1[line] = new CharPointer(data, dp);
		//		*(int *)pp1[line] = -2;
		pp1[line].assignInt(-2);
		dp += STYLE_HEAD;
		//		pp2[line] = data+dp;
		pp2[line] = new CharPointer(data, dp);
		
		for(i = 0; i <= len; i++){
		    //		    *(data+dp+i) = buff[i];
		    data[dp + i] = buff[i];
		}
		dp += len + 1;
		//#ifdef JMX
		//		dp += (4 - /*(unsigned)*/(data+dp) % 4) % 4 ;
		//#endif
		line++;
	    }
	    else if(c == '#'){
		ungetc(c,fp);
		if (stend == 1){
		    stend = 0;
		}
		len_p = new Int(0);
		if(wleft(buff, fp, len_p, 80, 1 + 2 + 8) == 0){
		    while(!(c == EOF || c == '\n')){
			c = getc(fp);
		    }
		}
		len = len_p.intValue();
		error = inif_set(buff);
	    }
	    else if(c == '%'){
		ungetc(c,fp);
		if(stend == 1){
		    stend = 0;
		}
		Int fline_p = new Int(fline);
		error = patths_set(fp, buff, fline_p);
		fline = fline_p.intValue();
		if (stend == 2){
		    error = 0;
		}
		if (error == 18){
		    stend = 2;
		}
		if (error == 20 || error == 22){
		    stend = 1;
		}
	    }
	    else if(c == '{'){
		ungetc(c,fp);
		len_p = new Int(0);
		if (wleft(buff, fp, len_p, 80, 1 + 2 + 8) == 0){
		    while(!(c == EOF || c == '\n')){
			c = getc(fp);
		    }
		}
		len = len_p.intValue();
		if (stend == 0){
		    error = 19;
		    stend = 1;
		}
	    }
	    else{
		int end0;
		
		ungetc(c,fp);
		if(stend == 1){
		    stend = 0;
		}		
		len_p = new Int(0);
		end0 = wleft(buff, fp, len_p, LMAX + 1, 4 + 8 + 16);
		len = len_p.intValue();
		if(len == 0){
		    continue;
		}
		error = set_patt(buff);
		if(error == 0){
		    error = set_ini(0);
		}		
		if(error == 0){
		    if(dp + len + 2 + STYLE_HEAD >= BLOCK_SIZE){
			data = malloc(BLOCK_SIZE);
			dp = 0;
		    }
		    
//		    pp1[line] = data+dp;
		    pp1[line] = new CharPointer(data, dp);
//		    ((struct patt_ini *)pp1[line])->style = throw_;
//		    ((struct patt_ini *)pp1[line])->height = hr0;
//		    ((struct patt_ini *)pp1[line])->dwell_ratio = dwell_ratio;
		    pp1[line].assignPattIni(throw_, hr0, dwell_ratio);
		    dp += STYLE_HEAD;
		    for(i = 0; i <= len; i++){
//			*(data+dp+i) = buff[i];
			data[dp + i] = buff[i];
		    }
		    dp += len + 1;
//#ifdef JMX
//		    dp += (4 - /*(unsigned)*/(data+dp) % 4) % 4;
//#endif
		    
		    if(end0 == 0){
			len_p = new Int(0);
			if(wleft(buff, fp, len_p, TMAX, 1 + 2 + 4 + 8) == 0){
			    while(!(c == EOF || c == '\n')){
				c = getc(fp);
			    }
			}
			len = len_p.intValue();
		    }
		    
		    if(end0 == 0 && len != 0){
			if(dp + len + 2 >= BLOCK_SIZE){
			    data = malloc(BLOCK_SIZE);
			    dp = 0;
			}
//			pp2[line] = data+dp;
			pp2[line] = new CharPointer(data, dp);
			for(i = 0; i <= len; i++){
//			    *(data+dp+i) = buff[i];
			    data[dp + i] = buff[i];
			}
			dp += len + 1;
//#ifdef JMX
//			dp += (4 - /*(unsigned)*/(data+dp)%4) % 4;
//#endif
		    }
		    else{
//			pp2[line] = pp1[line] + STYLE_HEAD;
			pp2[line] = new CharPointer(pp1[line], STYLE_HEAD);
		    }
		    line++;
		}
		else{
		    if(end0 == 0){
			while(!(c == EOF || c == '\n')){
			    c = getc(fp);
			}
		    }
		}
	    }
	}
//	fclose(fp);
        try {
            fp.close();
        }
        catch (IOException e){
        }
	throw_ = 0;
	
	for(flag = 0; flag < line; flag++){
//	    if (*(int *)pp1[flag] != -2){
	    if (pp1[flag].intValue() != -2){
		break;
	    }
	}
	
	if(flag == line){
//	    pbuf = fbuf;
	    return 16;
	}
	
//#ifdef JMX
	nTitles = line;
	x11.gr_init(1);
//#endif
//	juggle_loop();

	return 0;
    }
    float fadd(float x,int k,float t){
	return (float)(Math.floor((x + t) * Math.pow(10, k) + .5)
		       / Math.pow(10, k));
    }
    void do_juggle(){
	int i;
	int tone = 0;

	if(mp == 0){
	    if(Extern.status == ST_PAUSE || Extern.status == ST_NONE){
		vsync_Count1 = 0;
		tone = 0;
		return;
	    }
	}
	
	if(mp == 0){
//	    char buf[10];
	    int attr = TX_REVERSE;
//	    sprintf(buf,"%2d ",vsync_Count1);
//	    if(back_on) wprint1( 0,24,buf,attr);
	}
	
	time_count += vsync_Count1;
	vsync_Count1 = 0;
	
	if (time_count < aw){
	    time_count = aw;
	}
	
	time_period = (int)((time_count - aw) / tw);
	/* if(time_period>32700) break;*/
	time_period %= pattw;
	
	for(i = 0; i < balln; i++){
	    if(juggle(b[i]) != 0 && beep != 0){
		tone = Math.max(tone, Math.abs(b[i].bh));
	    }
	}
	if(juggle(rhand) + juggle(lhand) > 0){
	    if(back_on == 1){
		patt_print(1);
	    }
	}
	
	put_balls_x(bm, r_bm, l_bm, bm_gc, r_bm_gc, l_bm_gc);
	
	x11.repaint();
    }
    int strlen(char s[]){
	int i;

	for (i = 0; s[i] != '\0'; i++)
	    ;
	return i;
    }
    void count_up_timer(){
	vsync_Count1++;
    }
    void setPatternInfo(int cline){
//	pbuf = pp1[cline] + STYLE_HEAD;
	CharPointer p = new CharPointer(pp1[cline], STYLE_HEAD);
	pbuf = p.getString();

//	throw=((struct patt_ini *)(pbuf-STYLE_HEAD))->style;
//	hr0=((struct patt_ini *)(pbuf-STYLE_HEAD))->height;
//	dwell_ratio=((struct patt_ini *)(pbuf-STYLE_HEAD))->dwell_ratio;
	CharPointer c = new CharPointer(pp1[cline], 0);
	throw_ = c.getStyle();
	hr0 = c.getHeight();
	dwell_ratio = c.getDwellRatio();

	set_patt(pbuf);
    }
    boolean NoPattern(int i){
	return pp1[i].intValue() == -2;
    }
    int findPatternLine(int i){
	if (i < 0){
	    return 0;
	}
	if (NoPattern(i)) {
	    int i0 = i;
	    while ( ++i < nTitles ){
		if ( !NoPattern(i) ){
		    break;
		}
	    }
	    if ( i == nTitles ){
		for ( i = i0-1 ; i >=0 ; --i ){
		    if ( !NoPattern(i) ){
			break;
		    }
		}
	    }
	}
	return i;
    }
    String get_pbuf(){
	int l;

	l = strlen(pbuf);
	return String.valueOf(pbuf, 0, l);
    }
    int get_balln(){
	return balln;
    }
    String styleName(){
	return patths[throw_].name;
    }
    int ch = EOF;
    int getc(InputStream f){
	int c;

	if (ch != EOF){
	    c = ch;
	    ch = EOF;
	    return c;
	}
	try {
	    c = f.read();
	}
	catch (IOException e){
	    c = EOF;
	}
	return c;
    }
    void ungetc(int c, InputStream dumy){
	ch = c;
    }
}
